function Calcolatrice() {
  this.clickReset();
}

Calcolatrice.prototype.clickReset = function() {
  this.ultimoTasto=null;
  this.primoPunto = true;
  this.ultimoOperatore=null; // "binario", "unario", "uguale"
  this.operatore=null;
  this.op1 = NaN; // serve solo come dichiarazione
  this.op2 = NaN; // serve solo come dichiarazione
  this.setDisplay(0);
}

Calcolatrice.prototype.clickCifra = function(cifra) {
  if (this.isUltimoTastoNumerico() == false) {
    this.setDisplay(cifra);
    this.primoPunto = true;
  }
  else if (cifra != "." || this.primoPunto == true) {
    this.addDisplay(cifra);
  }

  if (cifra == ".") this.primoPunto = false;
  this.ultimoTasto = cifra;
  return;
}

Calcolatrice.prototype.clickOperatoreUnario = function(operatore) {
  var operando = parseFloat(this.getDisplay());
  var r = this.eseguiOperazioneUnaria(operatore,operando)
  this.setDisplay(r);

  this.ultimoOperatore = "unario";
  this.ultimoTasto = operatore;
  return;
}

Calcolatrice.prototype.clickOperatoreBinario = function(operatore) {
  if (this.isUltimoOperatoreUguale() == true ||
      this.isOperazioneInCorso() == false ||
      this.isUltimoTastoBinario() == true) {
        this.op1 = parseFloat(this.getDisplay());
        this.operatore = operatore;
  }
  else if (this.isOperazioneInCorso() == true) {
    this.op2 = parseFloat(this.getDisplay());
    var r =this.eseguiOperazioneBinaria(this.op1,this.operatore,this.op2);
    this.setDisplay(r);
    this.op1 = r;
    this.operatore = operatore;
  }
  
  this.ultimoOperatore = "binario";
  this.ultimoTasto = operatore;
  return;
}

Calcolatrice.prototype.clickOperatoreUguale = function() {
  if (this.isOperazioneInCorso() == true && this.isUltimoOperatoreUguale() == false) {
    this.op2 = parseFloat(this.getDisplay());
  }
  if (this.isOperazioneInCorso() == true) {
    var r =this.eseguiOperazioneBinaria(this.op1,this.operatore,this.op2);
    this.setDisplay(r);
    this.op1 = r;
  }

  this.ultimoOperatore = "uguale";
  this.ultimoTasto = "=";
  return;
}








Calcolatrice.prototype.isUltimoTastoNumerico = function() {
  var s =".0123456789";
  var i = s.indexOf(this.ultimoTasto);
  if (i>=0) return true;
  else return false;
}
Calcolatrice.prototype.isUltimoTastoBinario = function() {
  var s ="+-*/^";
  var i = s.indexOf(this.ultimoTasto);
  if (i>=0) return true;
  else return false;
}
Calcolatrice.prototype.isUltimoTastoUguale = function() {
  if (this.ultimoTasto == "=") return true;
  else return false;
}
Calcolatrice.prototype.isUltimoOperatoreUguale = function() {
  if (this.ultimoOperatore == "uguale") return true;
  else return false;
}
Calcolatrice.prototype.isOperazioneInCorso = function() {
  if (this.operatore != null) return true;
  else return false;
}

Calcolatrice.prototype.getDisplay = function(valore) {
    var visore = document.getElementById("calcolatrice_display");
    return visore.innerHTML;
}
Calcolatrice.prototype.setDisplay = function(valore) {
    var visore = document.getElementById("calcolatrice_display");
    visore.innerHTML= valore;
}
Calcolatrice.prototype.addDisplay = function(valore) {
    var n = this.getDisplay();
    this.setDisplay(n+valore);
}





Calcolatrice.prototype.eseguiOperazioneUnaria =function(operatore,operando) {
  var r = operando;
  switch (operatore) {
    case "-/+": r = -r; break;
    case "sqrt": r = Math.sqrt(r); break;
    default: alert("Operatore >"+operatore+"< non previsto"); r = 0;
  }
  return r;
}

Calcolatrice.prototype.eseguiOperazioneBinaria = function(o1,op,o2) {
  var r;
  switch (op) {
    case "+": r = o1 + o2; break;
    case "-": r = o1 - o2; break;
    case "*": r = o1 * o2; break;
    case "/": r = o1 / o2; break;
    case "^": r = Math.pow(o1,o2); break;
    default: alert("Operatore >"+op+"< non previsto"); r = 0;
  }
  return r;
}
